/** @file
 * @brief	˥Υޥ
 *
 * @date	2002.03.02
 * @author	Takashi SHUDO
 */

#include "shell.h"
#include "lineedit.h"
#include "str.h"
#include "conio.h"
#include "sformat.h"
#include "tprintf.h"
#include "task.h"
#include "disasm.h"
#include "section.h"
#include "commands.h"

#define	MAXBUF	60	//!< ǥɽS-recordsǡΣԤĹ
static char sbuf[MAXBUF];	//!< ʸХåե

/**
 * @brief	S-recordsǡΥ
 * @param[in]	argc	ޥɰο
 * @param[in]	argv	ޥɰʸΥݥ
 * @return	ޥɼ¹Է
 */
static int com_load(int argc, char *argv[])
{
	unsigned char *add;
	unsigned char *tadd = (unsigned char *)0xffffffff;
	unsigned char *badd = 0;
	unsigned long len;
	unsigned char bbuf[MAXBUF/2];
	unsigned char flgXflow = 0;
	unsigned char flgVfy = 0;
	unsigned char flgAddDsp = 0;
	short i;

	for(i=1; i<argc; i++) {
		switch(argv[i][0]) {
		case 'x':
			tprintf("X-Flow On.\n");
			flgXflow = 1;
			break;
			
		case 'v':
			tprintf("Verify mode.\n");
			flgVfy = 1;
			break;
			
		case 'a':
			flgAddDsp = 1;
			break;
		}
	}

	tprintf("Please send S-records data.\n");

	/*
	 * ɤ߹
	 */
	for(;;) {

		char rd = 0;
		char *dp = sbuf;
		
		for(;;) {
			long rt = 0;
			while(rt == 0) {
				rt = cgetc(&rd);
			}

			if(rd == CTRL_C) {
				tprintf("Canceled.\n");
				return 0;
			}

			if(rd == '\n') {
				// 
			} else if(rd != '\r') {	/* 	*/
				*dp = rd;
				dp ++;
				if(dp >= &sbuf[MAXBUF]) {
					tprintf("Line too long.\n");
					return 0;
				}
			} else {
				*dp = 0;
				break;
			}
		}

		if(flgXflow) {
			cputc(XON);	// X Stop
		}
		
		switch(DecodeSFormat(sbuf, &add, &len, bbuf)) {
		case 0:
			// ե̾
			if(flgAddDsp) {
				bbuf[len] = 0;
				tprintf("File : %s\n", bbuf);
			}
			break;
			
		case 1:
		case 2:
		case 3:
			// ǡ
			{
				unsigned char *sp, *dp = bbuf;
				if(tadd > add) {
					tadd = add;
				}
				if(badd < (add+len)) {
					badd = (add+len);
				}

				if(flgAddDsp) {
					tprintf(ADDR_PRINT_FORMAT "\r",
						(long)(INTPOINTER)add);
				}

				for(sp=add; sp<(add+len); sp++) {
					unsigned char *wp = sp;
					
					// ٥ơ֥ؤν񤭹
					// ϲۥ٥Υɥ쥹
					if((VECT_START <= (INTPOINTER)sp) &&
					   ((INTPOINTER)sp < VECT_END)) {
						wp += VVECT_START;
					}
					if(flgVfy == 0) {
						*wp = *dp;
					}
					if(*wp != *dp) {
						tprintf("Verify Error at "
							ADDR_PRINT_FORMAT
							" W:%02X R:%02X\n",
							wp, (int)*dp, (int)*wp);
					}
					dp ++;
				}
			}
			break;

		case 7:
		case 8:
		case 9:
			// λȥ꡼ɥ쥹
			{
				volatile long i;
				
				add = 0;
				for(i=0; i<len; i++) {
					add = (unsigned char *)
						((((INTPOINTER)add) << 8)
						 + bbuf[i]);
				}
				task_reg.name.pc = (INTPOINTER)add;

				tprintf("Load address     : "
					ADDR_PRINT_FORMAT " - "
					ADDR_PRINT_FORMAT "\n",
					(long)((INTPOINTER)tadd),
					(long)((INTPOINTER)badd)-1);
				tprintf("Excution address : "
					ADDR_PRINT_FORMAT "\n",
					(long)((INTPOINTER)add));
				tprintf("Done.\n");
				goto end;
			}
			break;

		case -1:// եޥåȥ顼
			tprintf("Format error:%s\n", sbuf);
			goto end;
			break;
		}
		
		if(flgXflow) {
			cputc(XOFF);	// X Start
		}
	}

 end:
	
	if(flgXflow) {
		cputc(XOFF);	// X Start
	}
	
	return 0;
}

/*----------------------------------------------------------------------------
  
----------------------------------------------------------------------------*/
static unsigned char *mdAddr;	//!< ץɥ쥹
static unsigned char dwi;	//!< 1:byte 2:word 4:long

/**
 * @brief	פν
 */
static void init_memdump(void)
{
	mdAddr = 0;
	dwi = 1;
}

/**
 * @brief	
 * @param[in]	argc	ޥɰο
 * @param[in]	argv	ޥɰʸΥݥ
 * @return	ޥɼ¹Է
 */
static int com_memdump(int argc, char *argv[])
{
	unsigned char *ed = mdAddr + 256;
	unsigned char *dp;
	unsigned char an = 1;

	if(argc > 1) {
		if(argv[1][0] == '-') {
			switch(argv[1][1]) {
			case 'b':
				dwi = 1;
				break;
				
			case 'w':
				dwi = 2;
				break;
				
			case 'l':
				dwi = 4;
				break;
			}
			
			an ++;
		} else {
			dwi = 1;
		}
	}
	
	if(argc > an) {
		mdAddr = (void *)(INTPOINTER)hstol(argv[an]);
		an ++;
	}
	
	ed	= mdAddr + 256;
		
	if(argc > an) {
		ed	= (unsigned char *)(INTPOINTER)hstol(argv[an]) + 1;
	}
	
	for(dp=mdAddr; dp<ed; dp+=16) {
		unsigned char *p;
		char rd;
		
		tprintf(ADDR_PRINT_FORMAT " : ", (long)(INTPOINTER)dp);
		
		for(p=dp; p<dp+8; p+=dwi) {
			switch(dwi) {
			case 1:	tprintf("%02X ", (int)*p);		break;
			case 2:	tprintf("%04X ", (int)*(short *)p);	break;
			case 4:	tprintf("%08lX ", (long)*(long *)p);	break;
			}
		}
		tprintf(" ");
		for(p=dp+8; p<dp+16; p+=dwi) {
			switch(dwi) {
			case 1:	tprintf("%02X ", (int)*p);		break;
			case 2:	tprintf("%04X ", (int)*(short *)p);	break;
			case 4:	tprintf("%08lX ", (long)*(long *)p);	break;
			}
		}
		
		tprintf("  \"");
		
		for(p=dp; p<dp+16; p++) {
			if(((' ' <= *p) && (*p <= 'Z'))
			   || (('a' <= *p) && (*p <= 'z'))) {
				cputc(*p);
			} else {
				cputc('.');
			}
		}
		tprintf("\"\n");
		
		if(cgetc(&rd) == 0) {
			if(rd == CTRL_C) {
				tprintf("Abort.\n");
				return 0;
			}
		}
	}
	
	mdAddr = ed;

	return 0;
}

/*----------------------------------------------------------------------------
  Խ
----------------------------------------------------------------------------*/
static void *meAddr;	//!< Խɥ쥹
static unsigned char wi;//!< 0:byte 1:word 2:long

/**
 * @brief	Խν
 */
static void init_memedit(void)
{
	meAddr = 0;
	wi = 0;
}

/**
 * @brief	Խ
 * @param[in]	argc	ޥɰο
 * @param[in]	argv	ޥɰʸΥݥ
 * @return	ޥɼ¹Է
 */
static int com_memedit(int argc, char *argv[])
{
	unsigned char an = 1;

	if(argc > 1) {
		if(argv[1][0] == '-') {
			switch(argv[1][1]) {
			case 'b':
				wi = 0;
				break;
				
			case 'w':
				wi = 1;
				break;
				
			case 'l':
				wi = 2;
				break;
			}
			
			an ++;
		} else {
			wi = 0;
		}
	}
	
	if(argc > an) {
		meAddr = (void *)(INTPOINTER)hstol(argv[an]);
		an ++;
	}
		
	if(argc > an) {
		// 񤭹ͤ

		short i;

		for(i=an; i<argc; i++) {

			switch(wi) {
			case 0:
				*(unsigned char *)meAddr =
						(unsigned char)hdstol(argv[i]);
				meAddr ++;
				break;
				
			case 1:
				*(unsigned short *)meAddr =
						(unsigned short)hdstol(argv[i]);
				meAddr += 2;
				break;
				
			case 2:
				*(unsigned long *)meAddr =
						(unsigned long)hdstol(argv[i]);
				meAddr += 4;
				break;
			}
		}
	} else {
		// 񤭹̵

		tprintf(ADDR_PRINT_FORMAT " : ", (long)(INTPOINTER)meAddr);

		switch(wi) {
		case 0:
			tprintf("%02X", (int)*(unsigned char *)meAddr);
			meAddr ++;
			break;

		case 1:
			tprintf("%04X", (int)*(unsigned short *)meAddr);
			meAddr += 2;
			break;

		case 2:
			tprintf("%08lX", (long)*(unsigned long *)meAddr);
			meAddr += 4;
			break;
		}
		
		tprintf("\n");
	}

	return 0;
}

/*****************************************************************************
	쥸
*****************************************************************************/
#define RN_R0	0
#define RN_R1	1
#define RN_R2	2
#define RN_R3	3
#define RN_R4	4
#define RN_R5	5
#define RN_R6	6
#define RN_R7	7
#define RN_SP	7
#define RN_CCR	8
#define RN_PC	9

static const char regName[][4] = {
	"R0", "R1", "R2", "R3", "R4", "R5", "R6", "R7", 
	"CCR", "PC",
	""
}; //!< 쥸̾ʸ

/**
 * @brief	ץ¹
 * @param[in]	argc	ޥɰο
 * @param[in]	argv	ޥɰʸΥݥ
 * @return	ޥɼ¹Է
 */
static int com_go(int argc, char *argv[])
{
	if(argc == 2) {
		task_reg.name.pc = hstol(argv[1]);
	}
	
	dispose_shell_line();	// ʤΤǤԽ饤˴
	exec_usertask();
	
	return 0;
}

/**
 * @brief	쥸ɽ
 */
static void disp_regs(void)
{
	unsigned char i, j;

	tprintf("%s = %06lX	 ", (char *)regName[9], task_reg.name.pc);
	tprintf("%s = %02X	 ", (char *)regName[8], task_reg.name.ccr);
	tprintf("\n");
	
	for(j=0; j<2; j++) {
		for(i=j*4; i<j*4+4; i++) {
			tprintf("%s = %08lX	 ",
				(char *)regName[i], task_reg.data[i]);
		}
		tprintf("\n");
	}
}

/**
 * @brief	쥸Խ
 * @param[in]	argc	ޥɰο
 * @param[in]	argv	ޥɰʸΥݥ
 * @return	ޥɼ¹Է
 */
static int com_reg(int argc, char *argv[])
{
	switch(argc) {
	case 1:
		disp_regs();
		break;

	case 2:
		/*
		 * "r regname"ν
		 */
		{
			short i = 0;
			
			while(regName[i][0] != 0) {
				if(strcomp((char *)regName[i],
					   str2cap(argv[1])) == 0) {
					tprintf("%s = %08lX\n",
						(char *)regName[i],
						task_reg.data[i]);
					return 0;
				}
				i ++;
			}
			
			tprintf("Register:%s unknown.\n", argv[1]);
		}
		break;

	case 3:
		/*
		 * "r regname val"ν
		 */ 
		{
			short i = 0;
			
			while(regName[i][0] != 0) {
				if(strcomp((char *)regName[i],
					   str2cap(argv[1])) == 0) {
					long val = hstol(argv[2]);
					task_reg.data[i] = val;
					tprintf("%s = %08lX\n",
						(char *)regName[i],
						task_reg.data[i]);
					return 0;
				}
				i ++;
			}
			
			tprintf("Register:%s unknown.\n", argv[1]);
		}
		break;
	}
	
	return 0;
}

/*----------------------------------------------------------------------------
  ե֥
----------------------------------------------------------------------------*/
#define MAXDABYTES	48	//!< 1εե֥Хȿ

static void *daAddr;	//!< ե֥륢ɥ쥹

/**
 * @brief	ե֥
 */
static void init_disa(void)
{
	daAddr = (unsigned char *)(INTPOINTER)task_reg.name.pc;
}

/**
 * @brief	ե֥ɽ
 * @param[in]	argc	ޥɰο
 * @param[in]	argv	ޥɰʸΥݥ
 * @return	ޥɼ¹Է
 */
static int com_disa(int argc, char *argv[])
{
	void *addr, *endAddr = daAddr + MAXDABYTES;

	switch(argc) {
	case 1:
		endAddr	= daAddr + MAXDABYTES;
		break;
		
	case 2:
		if(argv[1][0] == 'p') {
			daAddr	= (unsigned char *)
					((INTPOINTER)task_reg.name.pc - 16);
		} else {
			daAddr	= (unsigned char *)(INTPOINTER)hstol(argv[1]);
		}
		endAddr	= daAddr + MAXDABYTES;
		break;
		
	case 3:
		daAddr	= (unsigned char *)(INTPOINTER)hstol(argv[1]);
		endAddr	= (unsigned char *)(INTPOINTER)hstol(argv[2]) + 1;
	}
	
//	daAddr	= (unsigned char *)((INTPOINTER)daAddr & 0xfffffffe);
//	endAddr	= (unsigned char *)((INTPOINTER)endAddr & 0xfffffffe);
	
	for(addr = daAddr; addr<endAddr;) {
		char rd;
		
		tprintf(ADDR_PRINT_FORMAT " : ", (long)(INTPOINTER)addr);
			
		addr += disasm(addr);
			
		tprintf("\n");
			
		if(cgetc(&rd) == 0) {
			if(rd == CTRL_C) {
				tprintf("Abort.\n");
				return 0;
			}
		}
	}
		
	daAddr = addr;
		
	return 0;
}

/**
 * @brief	˼¹Ԥ̿ե֥ɽ
 */
void disp_next_order(void)
{
	disp_regs();
	
	tprintf(ADDR_PRINT_FORMAT " : ", task_reg.name.pc);
	
	disasm((void *)(INTPOINTER)task_reg.name.pc);

	tprintf("\n");
}

/**
 * @brief	ƥå׼¹
 * @param[in]	argc	ޥɰο
 * @param[in]	argv	ޥɰʸΥݥ
 * @return	ޥɼ¹Է
 */
static int com_step(int argc, char *argv[])
{
	dispose_shell_line();	// ʤΤǤԽ饤˴
	step_exec_usertask();

	return 0;
}


/**
 * @brief	֥졼ݥ
 * @param[in]	argc	ޥɰο
 * @param[in]	argv	ޥɰʸΥݥ
 * @return	ޥɼ¹Է
 */
static int com_break(int argc, char *argv[])
{
	int i;

	switch(argc) {
	case 1:
		for(i=0; i<MAX_BREAKPOINT_NUM; i++) {
			if(break_buf[i].addr != 0) {
				tprintf("%1d : " ADDR_PRINT_FORMAT "\n",
					i+1,
					(long)(INTPOINTER)break_buf[i].addr);
			}
		}
		break;
		
	case 2:
		{
			if(argv[1][0] == '-') {
				
				delete_all_breakpoints();
				
				tprintf("Deleted all breakpoints.\n");
				
			} else {
				volatile unsigned short *addr
					= (unsigned short *)(INTPOINTER)
						(hstol(argv[1]) & 0xfffffffe);

				// ѤߤΥɥ쥹ǧ
				for(i=0; i<MAX_BREAKPOINT_NUM; i++) {
					if(break_buf[i].addr ==  addr) {
						tprintf("Address "
							ADDR_PRINT_FORMAT
							" allready set to"
							" breakpoint.\n",
						(long)(INTPOINTER)addr);
						return 0;// Ѥߤä
					}
				}

				for(i=0; i<MAX_BREAKPOINT_NUM; i++) {
				  if(break_buf[i].addr == 0) {// ̤ꡩ

					  // ̿¸
					  break_buf[i].code = *addr;
					  
					  // ɥ쥹ROM
					  // ǧ뤿
					  *addr = BREAK_CODE;
					  
					  // 񤱤
					  if(*addr == BREAK_CODE) {
						  // 񤱤
						  
						  break_buf[i].addr = addr;
						  // ɥ쥹¸
						  *addr = break_buf[i].code;
						  // ᤹
						  
						  tprintf("Set breakpoint at "
							  ADDR_PRINT_FORMAT "\n",
							  (long)(INTPOINTER)addr);
					  } else {
						  // 񤱤ʤ
						  
						  *addr = break_buf[i].code;
						  // ᤹
						  tprintf("Cannot Set breakpoint at "
							  ADDR_PRINT_FORMAT
							  ".\n",
							  (long)(INTPOINTER)addr);
					  }
					  break;
				  }
				}
				
				if(i == MAX_BREAKPOINT_NUM) {
					tprintf("Breakpoint Full .\n");
				}
			}
		}
		break;

	case 3:
		if(argv[1][0] == '-') {
			if(strleng(argv[2]) == 1) {
				// Break # Ǿõ

				unsigned char num = dstol(argv[2]);

				if((1 <= num) && (num <= MAX_BREAKPOINT_NUM)) {
					break_buf[num-1].addr = 0;
					tprintf("Deleted breakpoint #%d.\n",
						(long)num);
				}
			} else {
				// ɥ쥹Ǿõ
				
				volatile unsigned short *addr
					= (unsigned short *)(INTPOINTER)
						(hstol(argv[2]) & 0xfffffffe);
			
				for(i=0; i<MAX_BREAKPOINT_NUM; i++) {
				  if(break_buf[i].addr == addr) {
					  break_buf[i].addr = 0;
					  tprintf("Deleted breakpoint address "
						  ADDR_PRINT_FORMAT ".\n",
						  (long)(INTPOINTER)addr);
				  }
				}
			}
		}
		break;
	}
	
	return 0;
}

/**
 * @brief	ե
 * @param[in]	argc	ޥɰο
 * @param[in]	argv	ޥɰʸΥݥ
 * @return	ޥɼ¹Է
 */
static int com_fill(int argc, char *argv[])
{
	unsigned char *wa, *sa, *ea, dt;
    
	if(argc >=  4) {
		sa = (unsigned char *)(INTPOINTER)hstol(argv[1]);
		if(argv[2][0] == '@') {
			ea = sa + hdstol(&argv[2][1]);
		} else {
			ea = (unsigned char *)(INTPOINTER)hstol(argv[2]);
        }
		dt = (unsigned char)hstol(argv[3]);

		for(wa = sa; wa <= ea; wa ++) {
			*wa = dt;
		}
	}

    return 0;
}

#define MEMCHK
#ifdef MEMCHK
/**
 * @brief	å
 * @param[in]	argc	ޥɰο
 * @param[in]	argv	ޥɰʸΥݥ
 * @return	ޥɼ¹Է
 */
static int com_memchk(int argc, char *argv[])
{
	unsigned long *sp = (unsigned long *)0x400000;
	unsigned long *ep = (unsigned long *)0x5fffff;
	unsigned long fd = 0;
	unsigned long *dp;
	unsigned long dt = 0;
	char rd;

	if(argc > 1) {
		sp = (unsigned long *)hstol(argv[1]);
	}

	if(argc > 2) {
		ep = (unsigned long *)hstol(argv[2]);
	}

	if(argc > 3) {
		fd = hstol(argv[3]);
	}

	tprintf("Memory check.\n");
	tprintf("Start  : " ADDR_PRINT_FORMAT "\n", (long)sp);
	tprintf("End    : " ADDR_PRINT_FORMAT "\n", (long)ep);
	tprintf("F.Data : %08lX\n", (long)fd);

	tprintf("Writing...\n");
	dt = fd;
	for(dp=sp; dp<=ep; dp++) {
		*dp = dt;
		if(*dp != dt) {
			tprintf("Verify Error at " ADDR_PRINT_FORMAT
				" W:%08lX R:%08lX\n", dp, dt, *dp);
		}
		dt ++;
		if(cgetc(&rd) == 0) {
			if(rd == CTRL_C) {
				tprintf("Abort.\n");
				return 0;
			}
		}
	}

	tprintf("Checking...\n");
	dt = fd;
	for(dp=sp; dp<=ep; dp++) {
		if(*dp != dt) {
			tprintf("Verify Error at " ADDR_PRINT_FORMAT
				" W:%08lX R:%08lX\n", dp, dt, *dp);
		}
		dt ++;
		if(cgetc(&rd) == 0) {
			if(rd == CTRL_C) {
				tprintf("Abort.\n");
				return 0;
			}
		}
	}

	return 0;
}
#endif

/**
 * @brief	ץƽ
 * @param[in]	argc	ޥɰο
 * @param[in]	argv	ޥɰʸΥݥ
 * @return	ޥɼ¹Է
 */
static int com_call(int argc, char *argv[])
{
	void (* func)(void);
	
	if(argc == 2) {
		func = (void *)hstol(argv[1]);
	} else {
		func = (void *)task_reg.name.pc;
	}

	func();
	
	return 0;
}

#define TCSR	(*(volatile unsigned short *)0xffff8c)

/**
 * @brief	ꥻå(åɥåޤ)
 * @param[in]	argc	ޥɰο
 * @param[in]	argv	ޥɰʸΥݥ
 * @return	ޥɼ¹Է
 */
static int com_reset(int argc, char *argv[])
{
	TCSR = 0xa578;	// åɥåޥꥻå

	return 0;
}
	
/**
 * @brief	Сɽ
 * @param[in]	argc	ޥɰο
 * @param[in]	argv	ޥɰʸΥݥ
 * @return	ޥɼ¹Է
 */
static int com_version(int argc, char *argv[])
{
	extern void print_version(void);

	print_version();

	return 0;
}
	
/*----------------------------------------------------------------------------
  إץåɽ
----------------------------------------------------------------------------*/
static int com_help(int argc, char *argv[]);

const struct shell_command mon_com[] = {
  /* ޥ	*/
  { "load",	"l", 0,		com_load,	0,
    "Load [x] [v] [a]"},
  { "reg",	"r", 0,		com_reg,	0,
    "Reg [[reg] val]"},
  { "go",	"g", 0,		com_go,		0,
    "Go [address]"},
  { "step",	"s", 0,		com_step,	CMDATTR_CTAL,
    "Step"},
  { "break",	"b", 0,		com_break,	0,
    "Break [[address]|[- address]]"},
  { "dump",	"d", init_memdump,com_memdump,	CMDATTR_CTAL,
    "Dump [-b|w|l] [start [end]]"},
  { "mem",	"m", init_memedit,com_memedit,	CMDATTR_CTAL,
    "Mem [-b|w|l] address [value ...]"},
  { "da",	"a", init_disa,	com_disa,	CMDATTR_CTAL,
    "disAsemble [address [end]]"},
  { "fill",	"f", 0, 	com_fill,	0,
    "Fill address end|@length value"},
  { "call",	"c", 0, 	com_call,	0,
    "Call [address]"},
#ifdef MEMCHK
  { "memck",	"", 0,		com_memchk,	0,
    "Memory check [Start [End [First data]]]"},
#endif
  { "reset",	"", 0,		com_reset,	0, "RESET"},
  { "ver",	"v", 0,		com_version,	0, "Version"},
  { "help",	"h", 0,		com_help,	0, "Help"},
  { "", "", 0, 0, 0, 0}	// ޥɥꥹȽλ
}; //!< إץå

/**
 * @brief	إץåɽ
 * @param[in]	argc	ޥɰο
 * @param[in]	argv	ޥɰʸΥݥ
 * @return	ޥɼ¹Է
 */
static int com_help(int argc, char *argv[])
{
	const struct shell_command *cp = mon_com;

	while(cp->name[0] != 0) {
		
		if(cp->help_str != 0) {
			tprintf(" [%1s] %5s : %s\n", cp->sname, cp->name,
				cp->help_str);
		}
		
		cp ++;
	}
	
	return 0;
}
