/** @file
 * @brief	H8/3068F,3069F BSC
 *
 * HM5117800(2M bytes DRAM,CS2,8bit³)
 *
 * ꥢɥ쥹:0x400000-0x5fffff
 *
 * _init()ǤϰʲνԤäƤ
 *
 * 1. H8/3664(Ρޥ⡼)ʳSYSCRUEӥåȤ0ˤ<br>
 * 2. SCI1(˥ǻѤSCI)γߥץ饤ƥӥåȤ1ˤ<br>
 * 3. ѤϥݡȡХȥνԤ<br>
 *
 * @date		2002.04.08
 * @author	Takashi Shudo
 */

#include "config.h"

// ե졼
const char cpu_name[] = "3069F";	//!< CPU̾
const unsigned char brr_val = 6;	//!< SCIӥåȥ졼(115200BPS 25MHz)
//const unsigned char brr_val = 10;	//!< SCIӥåȥ졼(57600BPS 20MHz)
//const unsigned char vbr_val = 5;	//!< SCIӥåȥ졼(115200BPS 22MHz)
const unsigned long init_pc_addr = 0x00400000;	//!< 桼ץPC
const unsigned long init_sp_addr = 0x00ffff20;	//!< 桼ץSP

/**
 * ƥॳȥ쥸
 */
union un_syscr {
	unsigned char BYTE;
	struct {
		unsigned char SSBY :1;
		unsigned char STS  :3;
		unsigned char UE   :1;
		unsigned char NMIEG:1;
		unsigned char SSOE :1;
		unsigned char RAME :1;
	} BIT;
};

#define SYSCR (*(volatile union un_syscr *)0xfee012)	//!< SYSCRΥɥ쥹

#define SCI1IPR				0xfee019	//!<SCI1IPRɥ쥹
#define SCI1IPRBIT			0x04		//!<SCI1IPRӥåȰ
#define SCI0IPR				0xfee019	//!<SCI0IPRɥ쥹
#define SCI0IPRBIT			0x08		//!<SCI0IPRӥåȰ

#define P1DDR (*(volatile unsigned char *)0xfee000)
#define P2DDR (*(volatile unsigned char *)0xfee001)
#define P6DDR (*(volatile unsigned char *)0xfee005)
#define P8DDR (*(volatile unsigned char *)0xfee007)

#define ADRCR (*(volatile unsigned char *)0xfee01e)
#define CSCR  (*(volatile unsigned char *)0xfee01f)
#define ABWCR (*(volatile unsigned char *)0xfee020)
#define ASTCR (*(volatile unsigned char *)0xfee021)
#define WCRH  (*(volatile unsigned char *)0xfee022)
#define WCRL  (*(volatile unsigned char *)0xfee023)
#define BCR   (*(volatile unsigned char *)0xfee024)

#define DRCRA (*(volatile unsigned char *)0xfee026)
#define DRCRB (*(volatile unsigned char *)0xfee027)
#define RTMCSR (*(volatile unsigned char *)0xfee028)
#define RTCNT (*(volatile unsigned char *)0xfee029)
#define RTCOR (*(volatile unsigned char *)0xfee02a)

/**
 * @brief	CPU
 */
void _init(void)
{
	volatile unsigned long i;
	
	*(unsigned char *)SCI1IPR |= SCI1IPRBIT;// SCI1ߥץ饤ƥ=1
	*(unsigned char *)SCI0IPR |= SCI0IPRBIT;// SCI0ߥץ饤ƥ=1

	SYSCR.BIT.UE = 0;	// UIӥåȤϳߥޥȤƻ
	
	// ݡ
	P1DDR = 0xff;	// A0-A7	
	P2DDR = 0x07;	// A8-A10	
	P6DDR = 0xb0;	// ~HWR,~WE	
	P8DDR = 0xe4;	// CS2		

	// BSC
	ABWCR = 0xff;	// CS0-CS7:8bitХ
	ASTCR = 0xfb;	// CS0-CS7:2ơȥ
	BCR   = 0xc6;	// 

	// DRAM
	RTCOR = 10;	// 1.5ms
	RTMCSR= 0x30;	// 2048
	DRCRB = 0x98;	// ॢɥ쥹10bit,PB4-5
	DRCRA = 0x3c;	// CS2:DRAM,եå(®ڡ⡼)
//	DRCRA = 0x30;	// CS2:DRAM,եå
	
	for(i = 0; i<100000; i++);

//	CSCR |= 0x30;	// CS4,CS5 (SG12232ѻ)
}

#define P8DR	(*(volatile unsigned char *)0xffffd7)	//!< P8DR

/**
 * @brief	ץꥱ¸ߤ뤫å
 * @return	0:ץꥱ̵ !=0:ץꥱͭ
 */
int check_application(void)
{
	if(*(unsigned long *)APP_ADDRESS != 0xfffffffL) {
		if((P8DR & 0x02) == 0) {	/* IRQ1(P81)ξ 0:
						 * Ƥܥ󤢤 */
			return 0;
		} else {
			return 1;
		}
	} else {
		return 0;
	}
}
