/** @file
 * @brief	饤󥨥ǥ
 *
 * ǽ
 * 
 * 饤󥨥ǥҥȥб<br>
 * VT100ߴΥߥʥ<br>
 * 
 * <br>
 * 		1b 5b 41<br>
 * 		1b 5b 42<br>
 * CTRL-P	10<br>
 * CTRL-N	0e		ҥȥ꡼<br>
 * 		1b 5b 44<br>
 * 		1b 5b 43	ư<br>
 * CTRL-A	01		Ƭ<br>
 * CTRL-B	02		ʸ<br>
 * CTRL-D	04		ʸ<br>
 * CTRL-E	05		<br>
 * CTRL-F	06		ʸ<br>
 * CTRL-H	08		ʸ(BS)<br>
 * CTRL-K	0b		ʹߤ<br>
 *
 * @date	2002.03.30
 * @author	Takashi SHUDO
 */

#include "lineedit.h"
#include "str.h"
#include "conio.h"


//!< lineedit.stat
enum {
	ESC0,	//!< ץ̤
	ESC1,	//!< ץ1Х
	ESC2,	//!< ץ2Х
};

/**
 * @brief	lineedit
 * @param[in]	le	lineedit
 */
void init_lineedit(struct lineedit *le)
{
	long i;

	for(i=0; i<MAX_LINE_COLUMS; i++) {
		le->buf[i] = 0;
	}
	le->cur_pos = 0;
	le->stat = ESC0;
}

/**
 * @brief	꥿ޤǤΣԽԤ
 *		ʸŤĥǡ
 * @param[in]	le	Խlineedit
 * @param[in]	ch	ʸ
 * @return	Խ(LER_*)
 */
long do_lineedit(struct lineedit *le, char ch)
{
	long i, j;

	switch(le->stat) {
	case ESC1:	// ץ󥹣Х
		switch(ch) {
		case 0x5b:
			le->stat = ESC2;
			break;

		default:
			le->stat = ESC0;
			break;
		}
		break;

	case ESC2:	// ץ󥹣Х
		switch(ch) {
		case 0x41:	// 
			le->stat = ESC0;
			return LER_BACKLINE;
			break;

		case 0x42:	// 
			le->stat = ESC0;
			return LER_NEXTLINE;
			break;

		case 0x44:	// 
			if(le->cur_pos != 0) {
				cputc(BS);
				le->cur_pos --;
			}
			le->stat = ESC0;
			break;

		case 0x43:	// 
			if(le->cur_pos < strleng(le->buf)) {
				cputc(le->buf[le->cur_pos]);
				le->cur_pos ++;
			}
			le->stat = ESC0;
			break;

		default:
			le->stat = ESC0;
			break;
		}
		break;

	default:
		switch(ch) {
		case 0x01:	// CTRL-A
			for(i=0; i<le->cur_pos; i++) {
				cputc(BS);
			}
			le->cur_pos = 0;
			break;

		case 0x02:	// CTRL-B
			if(le->cur_pos != 0) {
				cputc(BS);
				le->cur_pos --;
			}
			break;

		case 0x03:	// CTRL-C
			break;

		case 0x04:	// CTRL-D
			j = strleng(le->buf);
			if(le->cur_pos < j) {
				for(i=le->cur_pos; i<(j-1); i++) {
					le->buf[i] = le->buf[i+1];
					cputc(le->buf[i]);
				}
				le->buf[j-1] = 0;
				cputc(' ');
				for(i=le->cur_pos; i<j; i++) {
					cputc(BS);
				}
			}
			break;

		case 0x05:	// CTRL-E
			for(i=le->cur_pos; i<strleng(le->buf); i++) {
				cputc(le->buf[i]);
				le->cur_pos ++;
			}
			break;

		case 0x06:	// CTRL-F
			if(le->cur_pos < strleng(le->buf)) {
				cputc(le->buf[le->cur_pos]);
				le->cur_pos ++;
			}
			break;

		case 0x07:
			break;

		case 0x7f:
		case BS:	// Хåڡ
			if(le->cur_pos > 0) {
				cputc(BS);
				j = strleng(le->buf);
				for(i=le->cur_pos; i<j; i++) {
					le->buf[i-1] = le->buf[i];
					cputc(le->buf[i]);
				}
				le->buf[j-1] = 0;
				cputc(' ');
				for(i=le->cur_pos; i<j; i++) {
					cputc(BS);
				}
				cputc(BS);
				le->cur_pos --;
			}
			break;

		case 0x09:
		case 0x0a:
			break;

		case 0x0b:	// CTRL-K
			cputc(0x1b);
			cputc(0x5b);
			cputc(0x4b);
			j = strleng(le->buf);
			for(i=le->cur_pos; i<j; i++) {
				le->buf[i] = 0;
			}
			break;

		case 0x0c:	// CTRL-L
			break;

		case CR:	// CTRL-M
			cputc(CR);
			cputc(LF);

			return LER_RETURN;
			break;

		case 0x0e:	// CTRL-N
			le->stat = ESC0;
			return LER_NEXTLINE;
			break;

		case 0x10:	// CTRL-P
			le->stat = ESC0;
			return LER_BACKLINE;
			break;

		case 0x11:	// CTRL-Q(X-ON)
			break;
			
		case 0x13:	// CTRL-S(X-OFF)
			break;
			
		case 0x0f:
		case 0x12:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1a:
			break;

		case ESC:	// ץ
			le->stat = ESC1;
			break;

		case 0x1c:
		case 0x1d:
		case 0x1e:
		case 0x1f:

		case 0x7e:
			break;

		default:	// ʸ
			{
				j = strleng(le->buf);
				
				if(j < MAX_LINE_COLUMS) {
					for(i=j; i>=le->cur_pos; i--) {
						le->buf[i] =
							le->buf[i-1];
					}
					le->buf[le->cur_pos] = ch;
					le->buf[j+1] = 0;
					
					for(i=le->cur_pos; i<=j; i++) {
						cputc(le->buf[i]);
					}
					
					for(i=le->cur_pos; i<j; i++) {
						cputc(BS);
					}
					
					le->cur_pos ++;
				}
			}
			break;
		}
	}

	return LER_NOP;
}

/**
 * @brief	ԽΥǥ(ޥɼ¹Ը˥Хåե˴)
 * @param[in]	le	Խlineedit
 */
void new_lineedit(struct lineedit *le)
{
	long i;

	for(i=0; i<MAX_LINE_COLUMS; i++) {
		le->buf[i] = 0;
	}
	
	le->cur_pos = 0;
}

/**
 * @brief	Խʸꤹ
 * @param[in]	le	ʸꤹlineedit
 * @param[in]	str	ꤹʸ
 */
void set_str_lineedit(struct lineedit *le, char *str)
{
	short i;

	// 
	for(i=0; i<le->cur_pos; i++) {
		cputc(BS);
	}
	cputc(0x1b);
	cputc(0x5b);
	cputc(0x4b);

	le->cur_pos = 0;
	
	for(i=0; i<MAX_LINE_COLUMS; i++) {
		le->buf[i] = str[i];
		if(le->buf[i] != 0) {
			cputc(le->buf[i]);
			le->cur_pos ++;
		} else {
			return;
		}
	}
}
