/** @file
 * @brief	H8/300H˥
 * 
 * @author Takashi SHUDO
 */

#include "mon.h"
#include "task.h"
#include "section.h"
#include "tprintf.h"
#include "commands.h"
#include "shell.h"
#include "stub.h"
#include "conio.h"
#include "monio.h"

static unsigned char mon_mode;	//!< ˥ư⡼

/**
 * @brief	˥ư⡼ɤꤹ
 * @param	mode	ꤹư⡼
 */
void set_monmode(unsigned char mode)
{
	mon_mode = mode;
}

/**
 * @brief	Сɽ
 */
void print_version(void)
{
	extern const char version[];
	extern const char cpu_name[];
	extern const char date[];
	extern const char time[];

	tprintf("\nH8/300(H) %s Monitor Ver. %s", cpu_name, version);
#ifdef DEBUG
	tprintf("(DEBUG Version)");
#endif
	tprintf("\n");

	tprintf("(c)2003,2004,2007 Takashi SHUDO\n");
	tprintf("  Virtual vector table area : "
		ADDR_PRINT_FORMAT " - " ADDR_PRINT_FORMAT "\n",
		(long)VVECT_START, (long)VVECT_END-1);
	tprintf("  Monitor used RAM area     : "
		ADDR_PRINT_FORMAT " - " ADDR_PRINT_FORMAT "\n",
		(long) BSS_START, (long)BSS_END-1);
	tprintf("  Monitor stack end address : "
		ADDR_PRINT_FORMAT "\n", (long)INIT_STACK);
	tprintf("  Build date                : %s %s\n", time, date);
}

/**
 * @brief	˥ᥤ롼
 */
void mon(void)
{
	char rd;
	
	switch(mon_mode) {
	case MMODE_MON:
		switch(task_status()) {
		case EXST_ABREAK:
			tprintf("Break.\n");
			
		case EXST_ASTEP:
			// ƥå׼¹Ԥä
			disp_next_order();
			print_prompt();
			break;
		}
		break;
		
	case MMODE_GDB:
		switch(task_status()) {
		case EXST_ASTEP:
			// ƥå׼¹Ԥä
			stub_send_signal();
			break;
			
		case EXST_ABREAK:
			// ֥졼ä
			stub_send_expected();
			break;
		}
		break;
	}
								  
	for(;;) {
		switch(mon_mode) {
		case MMODE_MON:
			if(cgetc(&rd)) {
				task_shell(rd);
			}
			
			if(stubgetc(&rd)) {
				if(rd == '$') {
					mon_mode = MMODE_GDB;
					stub_init();
					stub_task(rd);
					tprintf("\n=== Stub mode ===\n");
				}
			}
			break;

		case MMODE_GDB:
			if(stubgetc(&rd)) {
				if(stub_task(rd)) {
					tprintf("\n== Monitor mode ==\n");
					mon_mode = MMODE_MON;
					print_prompt();
				}
			}
			break;
		}
	}
}
