/** @file
 * @brief	˥I/OǥХ
 *
 * @date	2007.03.11
 * @author	Takashi SHUDO
 */

#include "monio.h"

static const struct st_monio *monio;	//!< ˥IOǥХ
static const struct st_monio *stubio;	//!< stub IOǥХ

/**
 * @brief	˥I/O
 * @param[in] io	˥IOݥ
 */
void init_monio(const struct st_monio *io)
{
	monio = io;

	monio->init();
}

/**
 * @brief	˥IOμǡ
 * @param[out]	rd	ǡݥ
 * @return	!=0:ǡ 0:ǡ̵
 */
unsigned char mgetc(char *rd)
{
	return monio->getc(rd);
}

/**
 * @brief	˥IOǡ
 * @param[out]	td	ǡ
 */
void mputc(char td)
{
	monio->putc(td);
}

/*
  stub I/O
*/

/**
 * @brief	stub I/O
 * @param[in] io	stub IOݥ
 */
void init_stubio(const struct st_monio *io)
{
	stubio = io;

	stubio->init();
}

/**
 * @brief	stub IOμǡ
 * @param[out]	rd	ǡݥ
 * @return	!=0:ǡ 0:ǡ̵
 */
unsigned char stubgetc(char *rd)
{
	return stubio->getc(rd);
}

/**
 * @brief	stub IOǡ
 * @param[out]	td	ǡ
 */
void stubputc(char td)
{
	stubio->putc(td);
}
