/** @file
 * @brief	ޥɥ
 *
 * @date	2007.03.16
 *		2002.03.24
 * @author	Takashi SHUDO
*/

#include "shell.h"
#include "lineedit.h"
#include "str.h"
#include "tprintf.h"
#include "history.h"

static struct lineedit	comLine;	//!< ޥɥ饤
static char lastCom[MAX_LINE_COLUMS+1];	//!< Ǹ˼¹Ԥޥ

static const struct shell_command *shell_coms;	//!< ˥ޥɥǡ١

static struct history his;	//!< ޥɥҥȥ

/**
 * @brief	
 * @param[in]	coms	shell_commandΥݥ
 */
void init_shell(const struct shell_command *coms)
{
	const struct shell_command *cp = coms;
	shell_coms = coms;
	lastCom[0] = 0;

	/*
	 * ƥޥɤν
	 */
	while(cp->name[0] != 0) {
		if(cp->init != 0) {
			cp->init();
		}
		cp ++;
	}

	init_history(&his);
	init_lineedit(&comLine);
}

static const char prompt[] = ">";	//!< ץץʸ

/**
 *	@brief	ץץȤɽ
 */
void print_prompt(void)
{
	tprintf((char *)prompt);
}

/**
 * @brief	ԽΥޥɥ饤˴
 */
void dispose_shell_line(void)
{
	new_lineedit(&comLine);
}


#define	MAXARGV	10	//!< ޥɰκ

static char *argv[MAXARGV];	//!< ޥɰ
static const char nstr[] = "";	//!< NULLʸ

/**
 * @brief	strʸΥޥɤ¹Ԥ
 * @param	str	ޥʸݥ
 * @return	ޥɼ¹Է
 */
static int do_shell_command(char *str)
{
	const struct shell_command *cp = shell_coms;
	int argc = 0;
	int ex = 0;
	int rt = 0;
	int i;
	int flgc = 0;
	char *tk;

	if(*str == 0) {
		flgc = 1;
		if(lastCom[0] != 0) {
			str = lastCom;
		} else {
			return 0;
		}
	} else {
		strcopy(lastCom, str);
	}

	tk = str;
	
//	str2small(str);	// ʸѴ

	/*
	 * ȡڤ
	 */
	for(i=0; i<MAXARGV; i++) {
		argv[i] = (char *)nstr;
	}

	for(i=0; i<MAXARGV; i++) {
		/*
		 * ' 'ʳʸƬ
		 */
		while(tk < &str[MAX_LINE_COLUMS]) {
			if((*tk == 0) || (*tk == CR)) {
				*tk = 0;
				goto next;
			} else if(*tk != ' ') {
				argv[i] = tk;
				argc ++;
				tk ++;
				break;
			}
			
			tk ++;
		}
		
		/*
		 *	' 'ޤɤ߼Τ
		 */
		while(tk < &str[MAX_LINE_COLUMS]) {
			if((*tk == 0) || (*tk == CR)) {
				*tk = 0;
				goto next;
			} else if(*tk == ' ') {
				*tk = 0;
				tk ++;
				break;
			}
			
			tk ++;
		}
	}
	
 next:

	while(cp->name[0] != 0) {
	    if((strcomp((char *)cp->name, argv[0]) == 0)
	       || (strcomp((char *)cp->sname, argv[0]) == 0)) {
		    if(cp->command != 0) {
			    if(flgc) {
				    if(cp->attr & CMDATTR_CONT) {
					    if(cp->attr & CMDATTR_ARGLESS) {
						    argc = 1;
					    }
					    rt = cp->command(argc, argv);
					    ex = 1;
				    } else {
					    goto end;
				    }
			    } else {
				    rt = cp->command(argc, argv);
				    ex = 1;
			    }
			    break;
		    }
	    }
	    cp ++;
	}
	
	if(ex == 0) {
		lastCom[0] = 0;
		tprintf("Invalid Command.\n");
	}

 end:
	
	return rt;
}


/**
 * @brief	ʸԽ
 * @param	ch	Խʸǡ
 * @return	ޥɼ¹Է
 */
int task_shell(char ch)
{
	int rt;

	if(ch == CTRL_C) {	// CTRL-C ?
		init_lineedit(&comLine);
		tprintf("\n");
		print_prompt();
	} else {
		switch(do_lineedit(&comLine, ch)) {
		case LER_NOP:
			break;
			
		case LER_RETURN: // '\r'ǥޥɼ¹
			save_history(&his, comLine.buf);
			rt = do_shell_command(comLine.buf);
			new_lineedit(&comLine);
			if(rt) {
				return rt;
			}
			print_prompt();
			return rt;
			break;

		case LER_BACKLINE:
			back_history(&his, &comLine);
			break;
			
		case LER_NEXTLINE:
			foward_history(&his, &comLine);
			break;
		}
	}

	return 0;
}

