/** @file
 * @brief	ʸ
 *
 * @date	2002.03.02
 * @author	Takashi SHUDO
 */

#include "str.h"

/*
 *	16ʿʸ<->16ʿѴ
 */

/**
 * @brief	long dataketa16ʿѴstrؽ
 * @param[out]	str	ʸݥ
 * @param[in]	val	ʸˤ
 * @param[in]	keta	ʸ(0-8)
 * @return	ʸݥ
 */
char *ltohs(char *str, unsigned long val, long keta)
{
	long i;
	unsigned long	mask = (0xf0000000>>((8-keta)*4));
	long tmp;

	for(i=0; i<keta; i++) {
		tmp = (val & mask) >> ((keta-1-i)<<2);
		if(tmp < 10) {
			*str = tmp + '0';
		} else {
			*str = tmp - 10 + 'a';
		}
		str ++;
		mask >>= 4;
	}
	*str = 0;

	return str;
}

/**
 * @brief	str16ʿʸ8ʸlongѴ
 * @param[in]	str		- 16ʿʸ
 * @return	Ѵ
 */
long hstol(char *str)
{
	long rt = 0;

	while(*str != 0) {
		rt <<= 4;
		if((('0' <= *str) && (*str <= '9'))
		   || (('A' <= *str) && (*str <= 'F'))
		   || (('a' <= *str) && (*str <= 'f'))) {
			if(('0' <= *str) && (*str <= '9')) {
				rt += *str - '0';
			} else
				if(('A' <= *str) && (*str <= 'F')) {
					rt += *str - 'A' + 10;
				} else
					if(('a' <= *str) && (*str <= 'f')) {
						rt += *str - 'a' + 10;
					}
		}
		str ++;
		if(*str == ';') {	// !!!
			break;
		}
	}

	return rt;
}

/**
 * @brief	str16ʿʸ2ʸunsigned charѴ
 * @param[in]	str		- 16ʿʸ
 * @return	Ѵ
 */
unsigned char hs2c(char *str)
{
	unsigned char i, rt = 0;
	
	for(i=0; i<2; i++) {
		rt <<= 4;
		if((('0' <= *str) && (*str <= '9'))
		   || (('A' <= *str) && (*str <= 'F'))
		   || (('a' <= *str) && (*str <= 'f'))) {

			if(('0' <= *str) && (*str <= '9')) {
				rt += *str - '0';
			} else if(('A' <= *str) && (*str <= 'F')) {
				rt += *str - 'A' + 10;
			} else if(('a' <= *str) && (*str <= 'f')) {
				rt += *str - 'a' + 10;
			}
		}
		str ++;
	}

	return rt;
}

/**
 * @brief	str16ʿʸ1ʸunsigned charѴ
 * @param[in]	str	16ʿʸ
 * @return	Ѵ
 */
unsigned char h2c(char *str)
{
	unsigned char rt = 0;
	
	if(('0' <= *str) && (*str <= '9')) {
		rt = *str - '0';
	} else if(('A' <= *str) && (*str <= 'F')) {
		rt = *str - 'A' + 10;
	} else if(('a' <= *str) && (*str <= 'f')) {
		rt = *str - 'a' + 10;
	}

	return rt;
}

/**
 * @brief	long valkt10ʿʸѴstrؽ
 * @param[out]	str	10ʿʸ
 * @param[in]	keta	
 * @param[in]	val	Ѵ
 * @return	Ѵʸݥ
 */
char *ltods(char *str, long keta, long val)
{
	long i, j;
	int m = 0;

	if(val < 0) {
		val = 0-val;
		m = 1;
	}

	for(i=0; i<keta; i++) {
		if(val == 0) {
			if(i == 0) {
				str[keta-1-i] = '0';
				i++;
			}
			for(j=0; j<(keta-i); j++) {
				str[j] = ' ';
			}
			if(m) {
				if((keta-i-1) >= 0) {
					str[keta-i-1] = '-';
				}
			}
			goto end;
		}
		str[keta-1-i] = (val % 10) + '0';
		val /= 10;
	}

 end:
	str[keta] = 0;

	return str;
}

/**
 * @brief	unsigned long valkt10ʿʸѴstrؽ(̵)
 * @param[out]	str	10ʿʸ
 * @param[in]	keta	
 * @param[in]	val	Ѵ
 * @return	Ѵʸݥ
 */
char *ultods(char *str, long keta, unsigned long val)
{
	long i, j;

	for(i=0; i<keta; i++) {
		if(val == 0) {
			if(i == 0) {
				str[keta-1-i] = '0';
				i++;
			}
			for(j=0; j<(keta-i); j++) {
				str[j] = ' ';
			}
			goto end;
		}
		str[keta-1-i] = (val % 10) + '0';
		val /= 10;
	}

 end:
	str[keta] = 0;

	return str;
}

/**
 * @brief	long valketa10ʿʸѴstrؽ("0"դ)
 * @param[out]	str	10ʿʸ
 * @param[in]	keta	
 * @param[in]	val	Ѵ
 * @return	Ѵʸݥ
 */
char *ltodsz(char *str, long keta, long val)
{
	long i, j;

	if(val < 0) {
		val = 0-val;
		str[0] = '-';
	} else {
		str[0] = '0';
	}

	for(i=0; i<keta; i++) {
		if(val == 0) {
			for(j=1; j<(keta-i); j++) {
				str[j] = '0';
			}
			goto end;
		}
		str[keta-1-i] = (val % 10) + '0';
		val /= 10;
	}

 end:
	str[keta] = 0;

	return str;
}

/**
 * @brief	unsigned long valketa10ʿʸѴstrؽ("0"դ,̵)
 * @param[out]	str	10ʿʸ
 * @param[in]	keta	
 * @param[in]	val	Ѵ
 * @return	Ѵʸݥ
 */
char *ultodsz(char *str, long keta, unsigned long val)
{
	long i, j;

	for(i=0; i<keta; i++) {
		if(val == 0) {
			for(j=0; j<(keta-i); j++) {
				str[j] = '0';
			}
			goto end;
		}
		str[keta-1-i] = (val % 10) + '0';
		val /= 10;
	}

 end:
	str[keta] = 0;

	return str;
}

/**
 * @brief	str10ʿʸ󤫤longѴ
 * @param[in]	str		- 10ʿʸ
 * @return	Ѵ
 */
long dstol(char *str)
{
	long rt = 0;
	char m = 0;

	while(*str != 0) {
		if(*str == '-') {
			m = 1;
		}
		rt *= 10;
		if(('0' <= *str) && (*str <= '9')) {
			rt += *str - '0';
		}
		str ++;
		if(*str == ';') {
			break;
		}
	}

	if(m) {
		rt = 0-rt;
	}

	return rt;
}

/**
 * @brief	ʸs1s2ӤƷ̤֤
 * @return	0:Ʊ -1:*s1<*s2 1:*s1>*s2
 */
long strcomp(const char *s1, const char *s2)
{
	while((*s1 != 0) || (*s2 != 0)) {
		if(*s1 > *s2) {
			return 1;
		} else
			if(*s1 < *s2) {
				return -1;
			}
		s1 ++;
		s2 ++;
	}

	return 0;
}

/**
 * @brief	ʸs1s2nʸʬӤƷ̤֤
 * @return	0:Ʊ -1:*s1<*s2 1:*s1>*s2
 */
long strncomp(const char *s1, const char *s2, long n)
{
	while(n) {
		if(*s1 > *s2) {
			return 1;
		} else
			if(*s1 < *s2) {
				return -1;
			}
		s1 ++;
		s2 ++;
		n --;
	}

	return 0;
}

/**
 * @brief	ʸsrcdestإԡ
 * @param[out]	dest	ԡʸݥ
 * @param[in]	src	ԡʸݥ
 * @return	ԡʸݥ
 */
char *strcopy(char *dest, const char *src)
{
	while(*src != 0) {
		*dest = *src;
		dest ++;
		src ++;
	}
	*dest = 0;

	return dest;
}

/**
 * @brief	ʸsrcdestnʸʬԡ
 * @param[out]	dest	ԡʸݥ
 * @param[in]	src	ԡʸݥ
 * @param[in]	n	ԡʸΥХȿ 
 * @return	ԡʸݥ
 */
char *strncopy(char *dest, const char *src, long n)
{
	while(n) {
		if(*src == 0) {
			break;
		}
		*dest = *src;
		dest ++;
		src ++;
		n --;
	}
	*dest = 0;

	return dest;
}

/**
 * @brief	ʸstrĹ֤
 * @param[in]	str	ʸΥݥ
 * @return	ʸΥХȿ
 */
long strleng(const char *str)
{
	long len = 0;

	while(*str) {
		len ++;
		str ++;
	}

	return len;
}

/**
 * @brief	ʸstrξʸʸˤ
 * @param[in]	str	ʸΥݥ
 * @return	ѴʸΥݥ
 */
char *str2cap(char *str)
{
	char *p = str;
	while(*str) {
		if(('a' <= *str) && (*str <= 'z')) {
			*str -= ('a' - 'A');
		}
		str ++;
	}

	return p;
}

/**
 * @brief	ʸstrʸʸˤ
 * @param[in]	str	ʸΥݥ
 * @return	ѴʸΥݥ
 */
char *str2small(char *str)
{
	char *p = str;
	while(*str) {
		if(('A' <= *str) && (*str <= 'Z')) {
			*str += ('a' - 'A');
		}
		str ++;
	}

	return p;
}

/**
 * @brief	ʸκǽ餬"#"ξ
 *		str10ʿʸ󤫤longѴ
 *		ʳ
 *		str16ʿʸ8ʸlongѴ
 * @param[in]	str	ʸΥݥ
 * @return	Ѵ
 */
long hdstol(char *str)
{
	if(*str == '#') {
		return dstol(&str[1]);
	} else {
		return hstol(str);
	}
}

/**
 * @brief	Ǥդͤ
 * @param[out]	dest	ͤꤵΥݥ
 * @param[in]	data	ꤹ
 * @param[in]	count	ꤹХȿ
 * @return	ͤꤵ줿Υݥ
 */
void *memoryset(void *dest, unsigned char data, long count)
{
	unsigned char *p = dest;
	
	while(count) {
		*p = data;
		p ++;
		count --;
	}
	
	return dest;
}

/**
 * @brief	򥳥ԡ
 * @param[out]	dest	ԡΥݥ
 * @param[in]	src	ԡΥݥ
 * @param[in]	num	ꤹХȿ
 * @return	ԡΥݥ
 */
void *memorycopy(void *dest, const void *src, long num)
{
	unsigned char *d = dest;
	unsigned char *s = (unsigned char *)src;
	
	while(num) {
		*d = *s;
		d ++;
		s ++;
		num --;
	}
	
	return dest;
}
