/** @file
 * @brief	H8/300H 3052,3067,3068,3069ꥢ(SCI0)ɥ饤(gdb stub)
 *
 * @date	2008.05.01
 * @author	Takashi SHUDO
 */
/*
  BBR
  
  å	25	22	20	16	15	(MHz)
  115200bps	6	5	-	-	3
  57600bps	13	11	10	-	7
  38400bbs	19	17	15	12	11
  19200bps	40	35	32	25	23
  9600pbs	80	71	64	51	48
*/

#include "monio.h"
#include "tprintf.h"
#include "fifo.h"
#include "task.h"

#define USETXI	//!< ߤȤ

#define SCI_ADD		0xffffb0	//!<SCI0Υɥ쥹(3052,3067,3068,3069)

#define	MAX_SCI_RXBUF_SIZE	80	//!< SCIμХåե
static struct fifo rfifo;		//!< fifo
static unsigned char rbuf[MAX_SCI_RXBUF_SIZE];	//!< Хåե

#ifdef USETXI
#define	MAX_SCI_TXBUF_SIZE	16	//!< SCIХåե
static struct fifo tfifo;		//!< fifo
static unsigned char tbuf[MAX_SCI_TXBUF_SIZE];	//!< Хåե
#endif

/**
 * SCI쥸¤
 */
struct st_sci {
	union {
		unsigned char BYTE;
		struct {
			unsigned char CA  :1;
			unsigned char CHR :1;
			unsigned char PE  :1;
			unsigned char OE  :1;
			unsigned char STOP:1;
			unsigned char MP  :1;
			unsigned char CKS :2;
		} BIT;
	} SMR;
	unsigned char	BRR;
	union {
		unsigned char BYTE;
		struct {
			unsigned char TIE :1;
			unsigned char RIE :1;
			unsigned char TE  :1;
			unsigned char RE  :1;
			unsigned char MPIE:1;
			unsigned char TEIE:1;
			unsigned char CKE :2;
		} BIT;
	} SCR;
	unsigned char	TDR;
	union {
		unsigned char BYTE;
		struct {
			unsigned char TDRE:1;
			unsigned char RDRF:1;
			unsigned char ORER:1;
			unsigned char FER :1;
			unsigned char PER :1;
			unsigned char TEND:1;
			unsigned char MPB :1;
			unsigned char MPBT:1;
		} BIT;
	} SSR;
	unsigned char RDR;
};

#define SCI	(*(volatile struct st_sci *)SCI_ADD)	//!< SCI쥸

/**
 * @brief	SCI
 * 8bit, stop bit 1, ѥƥ̵, ĴƱ
 * ߻
 */
static void stubio_init(void)
{
	int i;

	extern const unsigned char brr_val;	// BRR
 
	init_fifo(&rfifo, rbuf, MAX_SCI_RXBUF_SIZE);
#ifdef USETXI
	init_fifo(&tfifo, tbuf, MAX_SCI_TXBUF_SIZE);
#endif

	SCI.SCR.BYTE	= 0x00;	// ޤꥢ
	SCI.SMR.BYTE	= 0x00;	// ĴƱ,8ӥå,ѥƥ̵,ȥå1,
	SCI.BRR		= brr_val;
	for(i=0; i<255; i++)	// 1ӥåȻְʾ奦
		;
	SCI.SCR.BYTE	= 0x70;	// ġߵ
	SCI.SSR.BIT.ORER= 0;
	SCI.SSR.BYTE	= 0x80;	// 顼ե饰ꥢ
}

/**
 * @brief	SCIμǡ
 * @param[out]	rd	ǡݥ
 * @return	!=0:ǡ 0:ǡ̵
 */
unsigned char stubio_getc(char *rd)
{
	return read_fifo(&rfifo, (unsigned char *)rd);
}

#ifdef USEINTRX
/**
 * @brief	SCIߥϥɥ
 */
void _tsub_sci_rxi(void) __attribute__((interrupt_handler));

void _tsub_sci_rxi(void)
{
	unsigned char rd;

	if(SCI.SSR.BIT.RDRF) {
		rd = SCI.RDR;		// ǡ
		write_fifo(&rfifo, rd);	// FIFOسǼ
		SCI.SSR.BIT.RDRF = 0;
	}
}
#endif

/**
 * @brief	SCI
 */
void _stub_rcv(void)
{
	unsigned char rd;

	if(SCI.SSR.BIT.RDRF) {
		rd = SCI.RDR;		// ǡ
		SCI.SSR.BIT.RDRF = 0;
		
		if(rd == 0x03) {	// CTRL-C
			break_task();
		}
		
		if(write_fifo(&rfifo, rd)) {	// FIFOسǼ
			DPRINTF("SCI0 Receive buffer full.\n");
		}
	}
}

/**
 * @brief	SCI顼ߥϥɥ
 */
void _stub_sci_eri(void) __attribute__((interrupt_handler));

void _stub_sci_eri(void)
{
	if(SCI.SSR.BIT.FER) {	// ե졼ߥ󥰥顼
		SCI.SSR.BIT.FER = 0;
	}

	if(SCI.SSR.BIT.PER) {	// ѥƥ顼
		SCI.SSR.BIT.PER = 0;
	}

	if(SCI.SSR.BIT.ORER) {	// С󥨥顼
		SCI.SSR.BIT.ORER = 0;	// С󥨥顼
	}
}

/**
 * @brief	SCIǡץƥߥϥɥ
 */
void _stub_sci_txi(void) __attribute__((interrupt_handler));

void _stub_sci_txi(void)
{
#ifdef USETXI
	unsigned char td;
	
	if(read_fifo(&tfifo, &td)) {
		SCI.TDR = td;
	
		SCI.SSR.BIT.TDRE = 0;
	} else {
		SCI.SCR.BIT.TIE = 0;
	}
#endif
}

/**
 * @brief	SCIλߥϥɥ(̤)
 */
void _stub_sci_tei(void) __attribute__((interrupt_handler));

void _stub_sci_tei(void)
{
	SCI.SCR.BIT.TEIE = 0;
}

/**
 * @brief	SCI
 * @param[in]	td	ǡ
 */
void stubio_putc(char td)
{
#ifdef USETXI
	while(write_fifo(&tfifo, td))
		;
	
	if(SCI.SCR.BIT.TIE == 0) {
		SCI.SCR.BIT.TIE = 1;
	}
#else
	SCI.TDR = td;

	SCI.SSR.BIT.TDRE = 0;
	
	while(!SCI.SSR.BIT.TEND)
	  ;
#endif
}

const struct st_monio stubsci_monio = {
	.init	= stubio_init,
	.getc	= stubio_getc,
	.putc	= stubio_putc
};
