/** @file
 * @brief	H8/300Hץ൯ưӥƥå׼¹ԡ֥졼ǽ
 *
 * @date	2002.03.22
 * @author	Takashi SHUDO
 */

#include "task.h"
#include "disasm.h"
#include "config.h"

extern void _exec(void);
extern void _exec_mon(void);

st_task	task_reg;	//!< 桼Υ쥸
st_task	break_reg;	//!< 桼Υ쥸(SCI߻)

struct break_pt	break_buf[MAX_BREAKPOINT_NUM];	//!< ֥졼ݥ

static unsigned char task_stat;		//!< 桼μ¹Ծ
static struct break_pt next_order;	//!< ƥå׼¹ԸΥɥ쥹̿
static struct break_pt bran_order;	//!< ֥¹ԸΥɥ쥹̿

/**
 * @brief	¹Υ֥졼߾֤
 */
void break_task(void)
{
	if(task_stat == EXST_EXEC) {
		task_reg = break_reg;
		task_stat = EXST_ABREAK;	// ֥졼߾֤
		
		_exec_mon();
	}

	return;
}

/**
 * @brief	ƥå׼¹Ԥä
 * @return	¹Ծ
 */
unsigned char task_status(void)
{
	return task_stat;
}

/**
 * @brief	Υ֥ޤ¹ԥɥ쥹˥ȥåפ񤭹
 */
static void prepare_trap_next_order(void)
{
	calc_next_pc((void *)((INTPOINTER)task_reg.name.pc), &task_reg,
		     (void *)&next_order.addr, (void *)&bran_order.addr);
	
	next_order.code	= *next_order.addr;	// ¸
	*next_order.addr = BREAK_CODE;		// ˥֥졼
	
	if(next_order.addr != bran_order.addr) {
		bran_order.code	= *bran_order.addr;	// ¸
		*bran_order.addr = BREAK_CODE;		// ˥֥졼
	}
}

/**
 * @brief	μ¹ԥɥ쥹֥졼ݥȡ
 * @return	1:ϥ֥졼
 */
static unsigned char next_order_is_break(void)
{
	short i;

	for(i=0; i<MAX_BREAKPOINT_NUM; i++) {
		if(task_reg.name.pc == (INTPOINTER)break_buf[i].addr) {
			return 1;
		}
	}

	return 0;
}

/**
 * @brief ƤΥ֥졼ݥȤꤷɥ쥹˥ȥå̿񤭹
 */
static void prepare_breakpoints(void)
{
	long i;

	for(i=0; i<MAX_BREAKPOINT_NUM; i++) {
		if(break_buf[i].addr != 0) {
			*break_buf[i].addr = BREAK_CODE;
		}
	}
}

/**
 * @brief	桼ץ¹
 */
void exec_usertask(void)
{
	if(next_order_is_break()) {
		// ¹Ԥ褦Ȥ̿᤬֥졼ݥȤä

		task_stat = EXST_NEXEC;	// ȥå׸¹ԤʤФʤʤ
		prepare_trap_next_order();

	} else {
		task_stat = EXST_EXEC;	// ¹Ծ֤
		prepare_breakpoints();	// ֥졼ȥåפ񤭹
	}
	
	_exec();	// ¹
}

/**
 * @brief	桼ƥå׼¹
 */
void step_exec_usertask(void)
{
	prepare_trap_next_order();
	
	task_stat = EXST_ESTEP;		// ƥå׼¹ԤΥե饰

	_exec();	// ¹
}

/*****************************************************************************
	֥졼ǽ

	֥졼ǽTRAPA̿ߤ
*****************************************************************************/

/**
 * @brief	֥졼ݥȤ
 */
void delete_all_breakpoints(void)
{
	long i;

	for(i=0; i<MAX_BREAKPOINT_NUM; i++) {
		break_buf[i].addr = 0;
	}
}

/**
 * @brief	֥졼ݥȤꤷɥ쥹Υȥå᤹̿
 */
void finish_breakpoints(void)
{
	long i;

	for(i=0; i<MAX_BREAKPOINT_NUM; i++) {
		if(break_buf[i].addr != 0) {
			*break_buf[i].addr = break_buf[i].code;	// ᤹̿
		}
	}

	if(task_stat == EXST_ESTEP) {	// ƥå׼¹Ԥä

		*next_order.addr = next_order.code;	// ¸Ƥ᤹̿
		if(next_order.addr != bran_order.addr) {
			*bran_order.addr = bran_order.code;	// ¸Ƥ᤹̿
		}
		
		task_stat = EXST_ASTEP;		// ƥå׼¹Ը֤

	} else if(task_stat == EXST_NEXEC) {	// ¹ԤΥƥå׼¹Ԥä

		*next_order.addr = next_order.code;	// ¸Ƥ᤹̿
		if(next_order.addr != bran_order.addr) {
			*bran_order.addr = bran_order.code;	// ¸Ƥ᤹̿
		}

		task_stat = EXST_EXEC;	// ¹Ծ֤
		prepare_breakpoints();	// ֥졼ȥåפ񤭹
		
		_exec();	// ⤦ټ¹
	} else {
		task_stat = EXST_ABREAK;	// ֥졼߾֤
	}
}

/**
 * @brief	桼ץξֽ
 */
void init_usertask(void)
{
	int i;
	
	extern const INTPOINTER init_pc_addr;	// 桼ץPC
	extern const INTPOINTER init_sp_addr;	// 桼ץSP

	task_reg.name.pc = break_reg.name.pc = init_pc_addr;	// PCν
	task_reg.name.sp = break_reg.name.sp = init_sp_addr;	// SPν
	task_reg.name.ccr= break_reg.name.ccr= 0x80;
	
	for(i=0; i<7; i++) {
		task_reg.data[i] = break_reg.data[i] = 0x0000000;
	}
	
	task_stat = EXST_RESET;
	
	delete_all_breakpoints();
}

/**
 * @brief	ǥХå
 */
void init_debuger(void)
{
	EnableSystemIRQ;	// ߵ
}
